Attribute VB_Name = "Module1"
Option Explicit
Declare Function GetPrinter Lib "winspool.drv" Alias "GetPrinterA" (ByVal hPrinter As Long, ByVal Level As Long, pPrinter As Any, ByVal cbBuf As Long, pcbNeeded As Long) As Boolean
Declare Function DeviceCapabilities Lib "winspool.drv" Alias "DeviceCapabilitiesA" (ByVal lpDeviceName As String, ByVal lpPort As String, ByVal iIndex As Long, lpOutput As Any, ByVal lpDevMode As Long) As Long
Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As Any) As Boolean
Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Public Const DC_BINNAMES = 12
Public Const DC_BINS = 6
Public Const CCHFORMNAME = 32
Public Const CCHDEVICENAME = 32
Public Const PRINTER_ENUM_LOCAL = &H2
Public Const PRINTER_ENUM_DEFAULT = &H1
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const PRINTER_ACCESS_ADMINISTER = &H4
Public Const PRINTER_ACCESS_USE = &H8
Public Const PRINTER_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED Or PRINTER_ACCESS_ADMINISTER Or PRINTER_ACCESS_USE)

Public Function ShareName$(nom$)
  'V 3.0
  'Paramtre : Une chaine reprsentant le DeviceName
  'Retour : Le nom de partage
  'Requis : OpenPrinter, GetPrinter, ClosePrinter
  Dim hPrinter&, BufferLen&, requis&, buffer() As Byte, ptr&, dummy$
  ShareName$ = ""
  Call OpenPrinter(nom$, hPrinter&, ByVal 0)
  Call GetPrinter(hPrinter&, 2, 0, 0, requis&)
  If requis& Then
    BufferLen& = requis&
    requis& = 0
    ReDim buffer(BufferLen&)
    Call GetPrinter(hPrinter&, 2, buffer(0), BufferLen&, requis&)
    'buffer contient des pointeurs sur 4 octets , on rcupre le 3me pointeur
    ptr& = buffer(8) + 256# * buffer(9) + 65536 * buffer(10) + 16777216 * buffer(11)
    dummy$ = Space$(32)                          'DOIT tre initialis
    Call CopyMemory(ByVal dummy$, ByVal ptr&, 32)
    ptr& = InStr(dummy$, Chr$(0))
    If ptr& > 0 Then ShareName$ = Left$(dummy$, ptr& - 1)
  End If
  Call ClosePrinter(hPrinter&)
End Function

Public Function ComputerName$()
  'V 2.1
  'Retour : Le nom d'ordinateur dans le rseau
  Dim retour$
  retour$ = Space$(50)                           'DOIT tre initialis
  If GetComputerName(retour$, 50) <> 0 Then ComputerName$ = Mid$(retour$, 1, InStr(retour$, Chr$(0)) - 1) Else ComputerName$ = ""
End Function
